class Editor.PicturePublisher.Dialog extends Editor.Dialog
  className: 'picture-publisher-dialog'
  
  getter_proxy: () ->
    proxy = super()
    # select lg
    @listenTo(proxy, 'next', @next)
    @listenTo(proxy, 'save:success', @success)
    @listenTo(proxy, 'save:fail', @fail)
    @listenTo(proxy, 'deny', @deny)
    @listenTo(proxy, 'unlock', @unlock)
    proxy
  
  proxy_class: () ->
    Pettanr.PublisherProxy
  
  poster_proxy: () ->
    proxy = new Pettanr.Proxy({})
    proxy
  
  http_post: (url, form) ->
    @poster_proxy().http_post(url, form)
  
  post: (params, form) ->
    @poster_proxy().post(params, form)
  
  deny: (params, form, safe_url) ->
    @getter_proxy().http_get(safe_url, params, form)
  
  next: (opl) ->
    @title({controller: 'original_picture_licenses', action: 'new'})
    @rb()
    @form = Locmare.Form.factory({
      form_name: opl.item_name(), 
      use_name: 'default', 
      item: opl, 
      element_form: false, 
      submit: 'default'
    })
    @listenTo(@form, 'confirm', @confirm)
    @form.render()
    this.$el.append(@form.el)
  
  confirm: (resource_picture, credits) ->
    @title({controller: 'resource_pictures', action: 'new'})
    @form = new Pettanr.Views.ResourcePicture.Form({
      resource_picture: resource_picture, credits: credits
    })
    @listenTo(@form, 'success', @success)
    this.$el.html('')
    this.$el.append(@form.render().el)
  
  success: (resource_picture) ->
    @trigger('success', resource_picture)
  
  quit: () ->
    @remove()
  
