class Pettanr.View.Show.Header extends Pettanr.View
  tagName: 'h1'
  className: 'show-header'
  
  constructor: (@item, @context, options) ->
    super(options)
  
  initialize: (options) ->
    @face_options = options.face
    @label_options = options.label
    @prof_options = options.prof
    
    @face_options.context ||= @context
    @face_options.class_name ||= 'face'
    @face_options.click ||= () =>
      @trigger('click:face')
    
    @label_options.context ||= @context
    @label_options.class_name ||= 'label'
    @label_options.click ||= () =>
      @trigger('click:label')
    
    @prof_options.context ||= @context
    @prof_options.class_name ||= 'prof'
    @prof_options.click ||= () =>
      @trigger('click:prof')
    
    @pick = null
    @face_button = @item.mini_face_button(@face_options)
    @label_button = @item.label_button(@label_options)
    @prof_button = @item.mini_prof_button(@prof_options)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@pick.render().el) if @pick
    this.$el.append(@face_button.render().el)
    this.$el.append(@label_button.render().el)
    this.$el.append(@prof_button.render().el)
    this
  
  click_pick: () ->
    @trigger('click:pick')
  
  add_pick: (target_model) ->
    @pick = new Pettanr.Views.Common.PickIcon({
      name: target_model.pick_type(@item.item_name()), half: true
    })
    @listenTo(@pick, 'click', @click_pick)
    @render()
  
