class Pettanr.View.Summary.Leaf extends Pettanr.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
    @binder_item_name = options.binder_item_name
    @destination_item_name = options.destination_item_name
    @binder_view = new Tag.Span({})
    @destination_view = new Tag.Span({})
    @load()
  
  load: () ->
    @listenTo(this, 'load_binder', @load_destination)
    @listenTo(this, 'load_destination', @ready)
    @load_binder()
  
  ready: () ->
    @trigger('ready')
  
  load_binder: () ->
    @item.get_parent(@binder_item_name, this, {
      success: (@binder) =>
        @binder_icon = @binder.icon_view(true)
        @listenTo(@binder_icon, 'click', @binder_click)
        @binder.get_parent('author', this, {
          success: (@binder_author) =>
            @binder_author_icon_with_caption = @binder_author.icon_with_caption_view(true, 'name', 12)
            @listenTo(@binder_author_icon_with_caption, 'click', @binder_author_click)
            @binder_view.$el.append(@binder_icon.render().el)
            @binder_view.$el.append(@binder_author_icon_with_caption.render().el)
            @trigger('load_binder')
        })
    })
  
  load_destination: () ->
    @item.get_parent(@destination_item_name, this, {
      success: (@destination) =>
        @destination_icon = @destination.icon_view(true)
        @listenTo(@destination_icon, 'click', @destination_click)
        @destination.get_parent('author', this, {
          success: (@destination_author) =>
            @destination_author_icon_with_caption = @destination_author.icon_with_caption_view(true, 'name', 12)
            @listenTo(@destination_author_icon_with_caption, 'click', @destination_author_click)
            @destination_view.$el.append(@destination_icon.render().el)
            @destination_view.$el.append(@destination_author_icon_with_caption.render().el)
            @trigger('load_destination')
        })
    })
  
  render: () ->
    this.$el.html('')
    this.$el.append(@binder_view.render().el)
    this.$el.append(@destination_view.render().el)
    this
  
  binder_click: () ->
    @trigger('http_get', @binder_icon.url())
  
  destination_click: () ->
    @trigger('http_get', @destination_icon.url())
  
  binder_author_click: () ->
    @trigger('http_get', @binder_author_icon_with_caption.url())
  
  destination_author_click: () ->
    @trigger('http_get', @destination_author_icon_with_caption.url())
  
