class PanelsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :edit, :create, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :edit, :create, :update, :destroy]
  else
    before_action :authenticate_reader, :only => [
      :index, :show, :by_scroll, :by_sheet, :by_author, :by_speech_balloon_template
    ]
    before_action :authenticate_user, :only => [:new, :edit, :create, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :edit, :create, :update, :destroy]
  end
  
  private
  def panel_list
    set_list
    @items = @finder
    @pager = @finder
    respond_to do |format|
      format.html 
      list_json_format @finder, format
      format.atom 
      format.rss
    end
  end
  public
  def index
    if params[:mode] == 'filer'
      filer_list
    else
      panel_list
    end
  end
  
  def by_scroll
    filer_list param: params[:id]
  end
  
  def by_sheet
    filer_list param: params[:id]
  end
  
  def by_author
    filer_list param: params[:id]
  end
  
  def by_speech_balloon_template
    filer_list param: params[:id]
  end
  
  def show_html_format format
    format.html {
      if @operators.author
        @new_scroll_items = assist_items('home', 'scrolls')
        @fresh_scroll_items = assist_items('home', 'scroll_panels').map {|sp| sp.scroll}
      end
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      if params[:with_elements]
        show_json_format_for_root format
      else
        show_json_format format
      end
    end
  end
  
=begin
  def new
    set_new
    respond_to do |format|
      format.html {
        @editor = Editor::PanelEditor.new @item, @operators
        render :template => @editor.template_name, :locals => {
          :editor => @editor
        }
      }
      format.json { render json: @item.to_json }
    end
  end
  
  def edit
    set_edit
    respond_to do |format|
      format.html {
        @editor = Editor::PanelEditor.new @item, @operators
        render :template => @editor.template_name, :locals => {
          :editor => @editor
        }
      }
      format.json { render json: @item.to_json }
    end
  end
=end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
#    @item.boosts 'post'
    jsn = nil
    if params[:json]
      jsn = JSON.parse_no_except(params[:json])
    end
    @prm = if params[:panel] == nil or params[:panel].empty?
      jsn
    else
      @item.permit_params(params)
    end
    @item.class.fold_extend_settings @prm
    #@item.refresh
    respond_to do |format|
      if @item.store @prm, @operators
        created_html_format format
        created_json_format format
      else
        not_created_html_format format
        not_created_json_format format
      end
    end
  end
  
  def update
    @item = Panel.edit(params[:id], @operators)
    @item.boosts 'post'
    jsn = nil
    if params[:json]
      jsn = JSON.parse(params[:json])
    end
    @prm = if params[:panel] == nil or params[:panel].empty?
      jsn
    else
      @item.permit_params(params)
    end
    @item.class.fold_extend_settings @prm
    # @item.refresh
    respond_to do |format|
      if @item.store @prm, @operators
        updated_html_format format
        updated_json_format format
      else
        not_updated_html_format format
        not_updated_json_format format
      end
    end
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    render_destroy '/home/' + @item.path_name
  end
  
end
