class OriginalPictureLicense < Peta::Item
  load_manifest
  belongs_to :original_picture
  belongs_to :license_group
  belongs_to :license
  
  validates :original_picture_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :license_group_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :license_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :license_group_module_name, :presence => true, :length => {:maximum => 50}
  validates :license_settings, :boost => {:boost_name => :license}
  
  def supply_default oid
    self.original_picture_id = oid
    self.license_group_id = nil
    self.license_id = nil
  end
  
  def self.build_resource_picture opl, original_picture, params
    my_model_class = ResourcePicture
    
    attr = params.merge(
      :license_group_id => opl.license_group_id,
      :system_picture_id => opl.license.system_picture_id,
      :license_group_module_name => opl.license_group.module_name,
      :license_group_settings => opl.license.license_group_settings,
      :credit_picture_settings => opl.license.credit_picture_settings
    )
    attr.delete :id
    resource_picture = my_model_class.new 
    resource_picture.attributes = attr
    resource_picture.overwrite original_picture
    resource_picture.boosts 'post'
    resource_picture
  end
  
end
