ManifestBase.require_modules "local_manifest/form/use/", 
  %w|field|

module LocalManifest
  module FormModule
    class Use < ManifestBase::NameValues
      include UseModule
      
      attr :fields, :field_names
      
      def set_default
        super
        @json['fields'] ||= {}
        @json['field_names'] ||= []
      end
      
      def init
        super
        @fields = ManifestBase.load_name_values self, @json, 'fields', Field
        @field_names = @json['field_names']
      end
      
      def each_field
        @field_names.each do |field_name|
          yield field_name, @fields[field_name]
        end
      end
      
      def ordered_fields
        @field_names.map do |field_name|
          @fields[field_name]
        end
      end
      
    end
    
  end
end

