ManifestBase.require_modules "manifest/model/association/", 
  %w|belongs_to has_many has_one|

module Manifest
  module ModelModule
    class Association < ManifestBase::Values
      include AssociationModule
      
      attr :belongs_to, :has_many, :has_one
      
      def set_default
        super
        @values['belongs_to'] ||= {}
        @values['has_many'] ||= {}
        @values['has_one'] ||= {}
      end
      
      def init
        super
        @belongs_to = ManifestBase.load_name_values self, @values, 'belongs_to', BelongsTo
        @has_many = ManifestBase.load_name_values self, @values, 'has_many', HasMany
        @has_one = ManifestBase.load_name_values self, @values, 'has_one', HasOne
      end
      
      def item_name
        @parent.item_name
      end
      
      def each_parent_model
        @belongs_to.each do |name, belongs_to_manifest|
          pm = @parent.classify
          next unless pm.element?
          if pm.my_peta.type == 'element'
            next unless belongs_to_manifest.model.my_peta.type == 'root'
          end
          if pm.my_peta.type == 'leaf'
            next unless belongs_to_manifest.model.my_peta.type == 'binder'
          end
          yield belongs_to_manifest.model
        end
      end
      
      def child_element_name child_model
        if has_one? child_model
          child_model.item_name
        else
          child_model.table_name
        end
      end
      
      def has_one? child_model
        if @has_one[child_model.item_name]
          true
        else
          false
        end
      end
      
    end
    
  end
end
