class Operator
  
  def initialize operators
    @operators = operators
    @operators = [@operators] unless @operators.respond_to?(:each)
    @operators.compact!
  end
  
  #InstanceMethods
  def find_user
    @operators.each do |operator|
      return operator if operator.is_a?(User)
      return operator.user if operator.is_a?(Author)
      return operator.user if operator.is_a?(Artist)
    end
    nil
  end
  
  def find_author
    @operators.each do |operator|
      return operator if operator.is_a?(Author)
      return operator.author if operator.is_a?(User)
      return operator.user.author if operator.is_a?(Artist) and operator.user.author
    end
    nil
  end
  
  def find_artist
    @operators.each do |operator|
      return operator.user.artist if operator.is_a?(Author) and operator.user.artist
      return operator.artist if operator.is_a?(User)
      return operator if operator.is_a?(Artist)
    end
    nil
  end
  
  def find_admin
    @operators.each do |operator|
      return operator if operator.is_a?(Admin)
    end
    nil
  end
  
  def user
    return @user if @user
    @user = find_user
  end
  
  def author
    return @author if @author
    @author = find_author
  end
  
  def artist
    return @artist if @artist
    @artist = find_artist
  end
  
  def admin
    return @admin if @admin
    @admin = find_admin
  end
  
  def guest?
    true
  end
  
  def reader?
    @operators.each do |operator|
      return true if operator.is_a?(Author) or operator.is_a?(Artist) or operator.is_a?(Admin) or operator.is_a?(User)
    end
    false
  end
  
  def user?
    @operators.each do |operator|
      return true if operator.is_a?(Author) or operator.is_a?(Artist) or operator.is_a?(User)
    end
    false
  end
  
  def resource_reader?
    @operators.each do |operator|
      return true if operator.is_a?(Author) or operator.is_a?(Artist) or operator.is_a?(Admin) or operator.is_a?(User) or operator.is_a?(DemandUser)
    end
    false
  end
  
  def admin?
    @operators.each do |operator|
      return true if operator.is_a?(Admin)
    end
    false
  end
  
end
